博客
关于我
LeetCode1035—不相交的线(java版)
阅读量:685 次
发布时间:2019-03-17

本文共 1385 字,大约阅读时间需要 4 分钟。

我们可以使用动态规划来解决这个问题。目标是在两条水平线上绘制尽可能多的连接线,前提是连接不相交且数字对应相同。

  • 动态规划定义:

    • 定义一个二维数组 dp,其中 dp[i][j] 表示在处理到 A 的前 i 个元素和 B 的前 j 个元素时可以绘制的最大连线数目。
  • 状态转移方程:

    • 如果 A[i-1] 等于 B[j-1],则我们可以在此处绘制一条新连线,所以 dp[i][j] = dp[i-1][j-1] + 1。
    • 否则,dp[i][j] 取决于上方或左方的值中的最大者,即 dp[i][j] = max(dp[i][j-1], dp[i-1][j])。
  • 初始化边界条件:

    • dp[0][*] 和 dp[*][0] 初始化为0,因为没有元素时无法绘制连线。
  • 填充动态规划表:

    • 遍历 A 和 B 的所有元素,逐步计算每个 dp[i][j] 的值,并更新全局最大值。
  • 通过这个方法,我们可以有效地计算出最大连线数,同时考虑了所有可能的绘制路径,避免了不必要的交叉。

    最终的代码实现如下:

    功能:计算可以绘制的最大连线数输入:两条整数序列A和B输出:最大连线数实现思路:使用动态规划,逐个比较A和B的元素,找出最长非交叉连接的数量。

    题目描述:

    标签:数组

    在两条水平线上按顺序写下整数A和B中的数字。可以绘制连接A[i]和B[j]的线,只要满足A[i]等于B[j]且线不交叉。目标找出最多可绘制的线条数。

    代码:

    class Solution { public int maxUncrossedLines(int[] A, int[] B) { int n1 = A.length; int n2 = B.length; int[][] dp = new int[n1 + 1][n2 + 1]; int result = 0; for (int i = 1; i <= n1; i++) { for (int j = 1; j <= n2; j++) { if (A[i - 1] == B[j - 1]) { dp[i][j] = dp[i-1][j-1] + 1; } else { dp[i][j] = Math.max(dp[i][j-1], dp[i-1][j]); } if (dp[i][j] > result) { result = dp[i][j]; } } } return result; } }

    转载地址:http://nadhz.baihongyu.com/

    你可能感兴趣的文章
    Python 接口自动化测试中的高阶函数
    查看>>
    python 控制 cmd 命令行颜色
    查看>>
    Python 操作 Azure Blob Storage
    查看>>
    Python 操作 Excel 全攻略 | 包括读取、写入、表格操作、图像输出和字体设置
    查看>>
    Python 操作 JMeter 探索:pymeter 实操指南
    查看>>
    Python 操作 Redis
    查看>>
    Python 操作Mysql(PyMysql)
    查看>>
    Python 操作Redis
    查看>>
    Python 操作sqlite数据库及保存查询numpy类型数据(一)
    查看>>
    Python 操作sqlite数据库及保存查询numpy类型数据(二)
    查看>>
    Python 数据文件与网络数据序列化存储详解
    查看>>
    Python 数据结构与算法详解
    查看>>
    Python 数据采集、清洗、整理、分析以及可视化实战
    查看>>
    Python 数据预处理
    查看>>
    Python 无法安装包
    查看>>
    python 日历小部件 - 返回用户选择的日期
    查看>>
    Python 日志管理封装
    查看>>
    python 时间函数小总结
    查看>>
    Python 是否优化尾递归?
    查看>>
    Python 更新set
    查看>>